import java.util.Random;

public class Array implements Structure {

	private int[] array;
	private int size;
	Random rnd;
	
	public Array(int size) {
		rnd = new Random();
		
		this.size = size;
		array = new int[size];
	}

	@Override
	public void insertQueue(int elem) {
		int[] tempArray = array;
		
		//Creation du nouveau tableau
		size ++;
		array = new int[size];
		
		//Insertion des valeurs dans le nouveau tableau
		for(int i = 0; i < size-1; i++) {
			array[i] = tempArray[i];
		}
		array[size-1] = elem;
	}

	@Override
	public void insertRandom(int elem) {
		int pos = rnd.nextInt(size);
		int[] tempArray = array;
		
		//Creation du nouveau tableau
		size ++;
		array = new int[size];
		
		//Insertion des valeurs dans le nouveau tableau
		for(int i = 0; i < pos; i++) {
			array[i] = tempArray[i];
		}
		
		array[pos] = elem;
		
		for(int i = pos+1; i < size; i++) {
			array[i] = tempArray[i-1];
		}
	}

	@Override
	public void insertHead(int elem) {
		int[] tempArray = array;
		
		//Creation du nouveau tableau
		size ++;
		array = new int[size];
		
		//Insertion des valeurs dans le nouveau tableau
		array[0] = elem;
		for(int i = 1; i < size; i++) {
			array[i] = tempArray[i-1];
		}
	}

	@Override
	public void remove(int pos) {
		int[] tempArray = array;
		
		//Creation du nouveau tableau
		size --;
		array = new int[size];
		
		//Insertion des valeurs dans le nouveau tableau
		for(int i = 0; i < pos; i++) {
			array[i] = tempArray[i];
		}	
		for(int i = pos+1; i < size; i++) {
			array[i] = tempArray[i];
		}
		
	}

	@Override
	public int get(int pos) {
		return array[pos];
		
	}
}
